/*
 *  Questions concerning this software should be directed to 
 *  Pavlin Ivanov Radoslavov (pavlin@catarina.usc.edu)
 *
 *  $Id: mtest.h,v 1.2 2000/09/06 16:19:42 pavlin Exp $
 */

#ifndef MTEST_H
#define MTEST_H

typedef unsigned int   u_int32;
typedef unsigned short u_int16;
typedef unsigned char  u_int8;
typedef          int   s_int32;
typedef          short s_int16;
typedef          char  s_int8;

#define MY_DELTA_TIME(time_end, time_start, time_total) \
do { \
    u_int32 _sec, _microsec; \
    _sec = ((time_end).tv_sec - (time_start).tv_sec); \
    if ((time_end).tv_usec >= (time_start).tv_usec) { \
      _microsec = (time_end).tv_usec - (time_start).tv_usec; \
    } else { \
      _sec--; \
      _microsec = 1000000 - ((time_start).tv_usec - (time_end).tv_usec); \
    } \
    (time_total).tv_sec += _sec; \
    (time_total).tv_usec += _microsec; \
    if ((time_total).tv_usec >= 1000000) { \
      (time_total).tv_sec++; \
      (time_total).tv_usec -= 1000000; \
    } \
} while (0)

#define AVE_RESULT(time_total, iterations, sec, microsec) \
do { \
    (sec) = (time_total).tv_sec/iterations; \
    (microsec) = (time_total).tv_sec%iterations; \
    (microsec) = (1000000*(microsec) + (time_total).tv_usec)/iterations; \
} while (0)

/* A structure for each packet being sent/received */
typedef struct
{
    u_short	seq_num;
    u_int8	mdestadd[4];
    u_short	port_no;
    u_short	length;
    char	data[10000];
} Packet;

#define MAX_LINESIZE 80

#define INFINITE      (u_long)~0x00000000

#endif /* MTEST_H */
